//***************************************************
//*
//*		SerialGate.dll  - COM port library
//*		Autor: Ivanov Dmitry Vasil`evich (2007-2008)
//*		http://www.pcports.ru
//*		mail: port@pcports.ru
//*		WARNING: Sources are free but do not abuse!
//*
//***************************************************

#ifndef SERIALGATE_H
#define SERIALGATE_H

#include <windows.h>

#define MAX_WIN_PORT 255

#define NO_WINSPOOL_LIB

struct Port
{
	unsigned char Id;
	bool Availbl;
};

struct PortInfo
{
	Port p[MAX_WIN_PORT];
	unsigned char koll;
};


extern "C" class SerialGate
{
public:

	enum IN_LINES_NAME {CTS, DSR, RING, RLSD};
	enum OUT_LINES_NAME {DTR, RTS};

	SerialGate();
	~SerialGate();

	bool Open(int port, int baud);
	int Send(char* buff, int szBuff);
	int Recv(char* buff, int szBuff);
	void SetLine(OUT_LINES_NAME ln, bool state);
	bool GetLine(IN_LINES_NAME ln);
#ifndef NO_WINSPOOL_LIB
	void GetPortsInfo(PortInfo* pi);
#endif // #ifndef NO_WINSPOOL_LIB
	void Close();
	void Clean();

private:
	HANDLE m_hFile;
	bool state;
};

#endif //#ifndef SERIALGATE_H

